unit Anagrammes;

interface

{$IF (RTLVersion < 20.0)}
  {$Message fatal 'ATTENTION ! Ce programme n'est pas fait pour tre compil sur des versions antrieures  Delphi 2009 !'}
{$IFEND}

{$Message hint 'Pensez  appeler "removeFromStringList" si vous utilisez "applyToStringList" et avant de librer la TStringList.'}

uses SysUtils, Windows, Classes, Generics.collections;


type
  PCharWord = ^TCharWord;
  TCharWord = packed record
     class function create(const aWord: string): TCharWord; static;

     class procedure applyToStringList(aStl: TStringList); static;
     class procedure removeFromStringList(aStl: TStringList); static;
     class function getFromStringList(aStl: TStringList; aIndex: integer): TCharWord; static;

     class operator equal(A, B: TCharWord): boolean;
     class operator LessThan(A, B: TCharWord): boolean;

     class operator explicit(const a: string): TCharWord;
     class operator implicit(const a: string): TCharWord;

     case integer of
      0 :(len: integer; chars: array[byte] of byte);
      1 :(mem: array[0..64] of longword);
  end;

const
  SizeOfTCharWord = SizeOf(TCharWord);

implementation


class procedure TCharWord.applyToStringList(aStl: TStringList);
var X: integer;
    P: PCharWord;
begin
  for X := 0 to aStl.Count - 1 do
  begin
    new(P);
    P^ := aStl[X];
    aStl.Objects[X] := TObject(P);
  end;
end;

class function TCharWord.create(const aWord: string): TCharWord;
var X, L: integer;
    B: byte;
begin
  for X := 0 to 64 do
    result.mem[X] := 0;

  result.len := Length(aWord);
  L := result.len;
  for X := 1 to L do
  begin
    B := byte(aWord[X]);
    case aWord[X] of
     {a} '','','','' : inc(result.chars[97]);
     {c} ''             : inc(result.chars[99]);
     {e} '','','','' : inc(result.chars[101]);
     {i} '','',''     : inc(result.chars[105]);
     {o} '','',''     : inc(result.chars[111]);
     {u} '','',''     : inc(result.chars[117]);
     {y} ''             : inc(result.chars[121]);
      else
        if (B >= 97) and (B <= (123)) then
          inc(result.chars[B])
        else
          dec(result.len);
    end;
  end;
end;

class operator TCharWord.equal(A, B: TCharWord): boolean;
begin
  result := A.len = B.len;
  if result then
    result := compareMem(@A, @B, SizeOfTCharWord);
end;

class operator TCharWord.explicit(const a: string): TCharWord;
begin
  result := TCharWord.create(a);
end;

class function TCharWord.getFromStringList(aStl: TStringList; aIndex: integer): TCharWord;
begin
  result := PCharWord(aStl.Objects[aIndex])^;
end;

class operator TCharWord.implicit(const a: string): TCharWord;
begin
  result := TCharWord.create(a);
end;


class operator TCharWord.LessThan(A, B: TCharWord): boolean;
var X: integer;
begin
  result := A.len > B.len;
  X := 0;
  while result and (x < 256) do
  begin
    result := A.chars[X] >= B.chars[X];
    inc(x);
  end;
end;

class procedure TCharWord.removeFromStringList(aStl: TStringList);
var X: integer;
    P: PCharWord;
begin
  for X := 0 to aStl.Count - 1 do
  begin
    P := PCharWord(aStl.Objects[X]);
    dispose(P);
    aStl.Objects[X] := nil;
  end;
end;

end.
