unit VMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, anagrammes;

type
  TForm8 = class(TForm)
    EdtSaisie: TEdit;
    LstResults: TListBox;
    LblPerf: TLabel;
    chkLessThan: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EdtSaisieChange(Sender: TObject);
    procedure chkGretterThanClick(Sender: TObject);
  private
    Words: TStringList;
  public
    { Dclarations publiques }
  end;

var
  Form8: TForm8;

implementation

{$R *.dfm}


procedure TForm8.chkGretterThanClick(Sender: TObject);
begin
  EdtSaisieChange(TObject(EdtSaisie));
end;

procedure TForm8.EdtSaisieChange(Sender: TObject);
var X: integer;
    A, B: TCharWord;
    G: LongWord;
begin
  if length(EdtSaisie.Text) < 1 then
    exit;

  A := EdtSaisie.Text;
  LstResults.Items.BeginUpdate;
  try
    G := GetTickCount;
    LstResults.Clear;
    for X := 0 to Words.Count-1 do
    begin
      B := TCharWord.getFromStringList(Words, X);
      if A = B then
        LstResults.Items.Add('= '+Words[X]);

      if chkLessThan.Checked then
        if A < B then
          LstResults.Items.Add('< '+Words[X]);

    end;
    G := GetTickCount-G;
  finally
    LstResults.Items.EndUpdate;
    LblPerf.Caption := format('%d mots trouvs, pour %d mots, en %.3f secondes',[LstResults.Count,Words.Count,G*0.001]);
  end;
end;

procedure TForm8.FormCreate(Sender: TObject);
begin
  Words := TStringList.Create;
  Words.LoadFromFile(extractFilePath(ParamStr(0))+'Liste_mots.txt');
  TCharWord.applyToStringList(Words);
  EdtSaisie.Text := 'atirer';
end;

procedure TForm8.FormDestroy(Sender: TObject);
begin
  TCharWord.removeFromStringList(Words);
  Words.Free;
end;

end.
